<?php
defined('BASEPATH') OR exit('No direct script access allowed');
?>
<div id="navigation">
	<nav class="navbar navbar-default">
		<div class="container-fluid">
			<!-- Brand and toggle get grouped for better mobile display -->
			<div class="navbar-header">
				<button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#navigation-collapse" aria-expanded="false">
					<span class="sr-only"><?php echo lang('navigation1'); ?></span>
					<span class="icon-bar"></span>
					<span class="icon-bar"></span>
					<span class="icon-bar"></span>
				</button>
				<a class="navbar-brand" href="#"><?php echo lang('navigation2'); ?></a>
			</div><!-- navbar-header -->
			<!-- Collect the nav links, forms, and other content for toggling -->
			<div class="collapse navbar-collapse" id="navigation-collapse">
				<?php echo form_open(current_url(), 'class="navbar-form navbar-left"');	?>
				<div class="form-group">
					<?php
					echo lang('navigation3') . '&nbsp;:&nbsp;';
					$options = array(
						'en' => 'English',
						'fr-FR' => 'Français'
					);
					echo form_dropdown('language', $options, $language, 'class="form-control"');
					?>
				</div><!-- form-group -->
				<?php
				echo form_submit('choice_of_language', lang('navigation4'), 'class="btn btn-primary"');
				echo form_close();
				?>
				<ul class="nav navbar-nav">
					<li<?php if (isset($home)) echo ' class="active"'; ?>><a href="<?php if (isset($home)) echo '#'; else echo site_url('welcome/index'); ?>"><?php echo lang('navigation5'); if (isset($home)) echo ' <span class="sr-only">' . lang('navigation6') . '</span>'; ?></a></li>
					<?php if ( $this->session->has_userdata('member_id') ): ?>
					<li<?php if (isset($research)) echo ' class="active"'; ?>><a href="<?php if (isset($research)) echo '#'; else echo site_url('welcome/research'); ?>"><?php echo lang('navigation7'); if (isset($research)) echo ' <span class="sr-only">' . lang('navigation6') . '</span>'; ?></a></li>
					<li<?php if (isset($your_conversations)) echo ' class="active"'; ?>><a href="<?php if (isset($your_conversations)) echo '#'; else echo site_url('welcome/your_conversations'); ?>"><?php echo lang('navigation8'); if (isset($your_conversations)) echo ' <span class="sr-only">' . lang('navigation6') . '</span>'; ?></a></li>
					<li<?php if (isset($log_out)) echo ' class="active"'; ?>><a href="<?php if (isset($log_out)) echo '#'; else echo site_url('welcome/log_out'); ?>"><?php echo lang('navigation9'); if (isset($log_out)) echo ' <span class="sr-only">' . lang('navigation6') . '</span>'; ?></a></li>
					<?php else: ?>
					<li<?php if (isset($register)) echo ' class="active"'; ?>><a href="<?php if (isset($register)) echo '#'; else echo site_url('welcome/register'); ?>"><?php echo lang('navigation10'); if (isset($register)) echo ' <span class="sr-only">' . lang('navigation6') . '</span>'; ?></a></li>
					<li<?php if (isset($log_in)) echo ' class="active"'; ?>><a href="<?php if (isset($log_in)) echo '#'; else echo site_url('welcome/log_in'); ?>"><?php echo lang('navigation11'); if (isset($log_in)) echo ' <span class="sr-only">' . lang('navigation6') . '</span>'; ?></a></li>
					<?php endif; ?>
				</ul>
			</div><!-- class="collapse navbar-collapse" id="navigation-collapse" -->
		</div><!-- container-fluid -->
	</nav><!-- navbar navbar-default -->
</div><!-- navigation -->
